<?php
	include("preg_find.php");
	$comment = "#";
	$confFile = "exec/mrb.conf";
	$dnldFld = "Unknown";

	$fp = fopen($confFile, "r");
	if ($fp) {
		while (!feof($fp)) {
			$line = trim(fgets($fp));
			if ($line == !ereg("^$comment", $line)) {
				$pieces = explode("=", $line);
				$option = trim($pieces[0]);
				if ($option === 'DownloadFolder') $dnldFld = trim($pieces[1]);
			}
		}
		fclose($fp);
	} else {
		die("Could not find mrb.conf file in exec/ folder. Please create a new one.");
		exit();
	}
	
	$services = " [Found: ";
	$files = preg_find('/./', 'exec/cookies', PREG_FIND_RECURSIVE|PREG_FIND_SORTKEYS|PREG_FIND_SORTDESC);
	foreach($files as $file) {
		if ($file === "exec/cookies/cookies_rapidshare") $services .= "R/";
		if ($file === "exec/cookies/cookies_netload") $services .= "N/";
		if ($file === "exec/cookies/cookies_hotfile") $services .= "H/";
	}
	$services .= " ]"; 

	$command = "exec/checkifrunning.sh";
    	$runState = (int)shell_exec($command);


?>

<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
   "http://www.w3.org/TR/html4/loose.dtd"><html>
    <head>
		<meta http-equiv="Pragma" content="no-cache">
        <title>MyRapBook Control Panel</title>
		<link REL="SHORTCUT ICON" HREF="favicon.ico">
        <link REL="STYLESHEET" TYPE="text/css" HREF="css/style.css" Title="MyRapBook_v0.2 CSS">
		<link rel="stylesheet" href="css/jquery.tooltip.css">
		<script language="JavaScript" src="js/jquery-1.3.2.min.js"></script>
		<script language="JavaScript" src="js/jquery.tooltip.pack.js"></script>
		<script language="JavaScript" src="js/jquery.dimensions.js"></script>
        <script language="javascript" type="text/javascript">
        <!--

        var server_response = "";
        var timerID = 0;
        var autoreload;
        var glb_progress_max = 570;
        var linkactivitychar = "|||";
	var frmSettingsState = 0;
	var glb_timeout;
		
		$(document).ready(function(){
			$('#lstUrls').tooltip({
				track: true,
				delay: 1,
				showURL: false,
				showBody: " - ",
				extraClass: "lstUrls",
				fixPNG: true,
				left: -120
			});
			$("#lstUrls").animate({ height: 'hide', opacity: 'hide' }, 'fast');
			$("#lstUrls").animate({ height: 'show', opacity: 'show' }, 'slow');
			settings_Toggle('fast');
			brg_Toggle('fast');
			brg_Toggle('slow');
			$('#ToggleViewLinks').tooltip({extraClass: "common"});
			$('#btnUploadUrls').tooltip({extraClass: "common"});
			$('#txtDaemonStatus').tooltip({extraClass: "common"});
			$('#btnStart').tooltip({extraClass: "common"});
			$('#btnStop').tooltip({extraClass: "common"});
			$('#btnGetStatus').tooltip({extraClass: "common"});
			$('#cbxAutoReload').tooltip({extraClass: "common"});
			$('#tbxReload').tooltip({extraClass: "common"});
			$('#tbxLinkActivity').tooltip({extraClass: "common"});
			$('#btnEditSettings').tooltip({extraClass: "common"});
			$('#btnGetDnlStatus').tooltip({extraClass: "common"});
			$('#btnGetHistory').tooltip({extraClass: "common"});
			$('#btnGetLog').tooltip({extraClass: "common"});
			$('#newDownloadFolder').tooltip({extraClass: "common"});
			$('#btnChangeDnlFld').tooltip({extraClass: "common"});
			$('#cbxService').tooltip({extraClass: "common"});
			$('#btnCreateCookie').tooltip({extraClass: "common"});
			$('#txtUsername').tooltip({extraClass: "common"});
			$('#txtPassword').tooltip({extraClass: "common"});
			$('#btnClearHistory').tooltip({extraClass: "common"});
			$('#btnClearLog').tooltip({extraClass: "common"});
			$('#ToggleViewProgr').tooltip({extraClass: "common"});
		 });
		 
		function links_Toggle() {
			$("#lstUrls").animate({ height: 'toggle', opacity: 'toggle' }, 'slow');
		}
		function settings_Toggle(speed) {
			$("#settingsForm").animate({ height: 'toggle', opacity: 'toggle' }, speed);
		}		 
		function brg_Toggle(speed) {
			$("#progressBar1").animate({ height: 'toggle', opacity: 'toggle' }, speed);
			$("#progressBar2").animate({ height: 'toggle', opacity: 'toggle' }, speed);
			$("#progressBar3").animate({ height: 'toggle', opacity: 'toggle' }, speed);
			$("#progressBar4").animate({ height: 'toggle', opacity: 'toggle' }, speed);
		}
		
		function OpenUrl(url)
		{
			window.open(url);
			return false;
		}

        function init() {
            changeProgress("1", 0);
            changeProgress("2", 0);
            changeProgress("3", 0);
            changeProgress("4", 0);

            //Set all elements to defaults
            period = document.getElementById('tbxReload');
            period.value = 2;

            tmpLinkActivity = document.getElementById('tbxLinkActivity');
            tmpLinkActivity.value = linkactivitychar;

            tmp_autoreload = document.getElementById('cbxAutoReload');
            tmp_autoreload.checked = false;
            autoreload = false;

            lstUrls = document.getElementById('lstUrls');
            lstUrls.value = "";
	    document.getElementById('newDownloadFolder').value = '<?php echo $dnldFld; ?>'; 

	    var runState = <?php echo $runState; ?>;
	    if (runState) document.getElementById('txtDaemonStatus').value = 'started';
	    else document.getElementById('txtDaemonStatus').value = 'stopped';

        }

        function StartUpdTimer() {
            period = document.getElementById('tbxReload').value;
            if (period >= 1) {
                timerID  = setTimeout("UpdateTimer()", period * 1000);
            }
        }

        function UpdateTimer() {
            if(timerID) {
                clearTimeout(timerID);
                clockID  = 0;
            }

            //Send request for downloads' state
            sendReq(1);

            if (autoreload) {
                StartUpdTimer();
            }
        }

        function SetAutoreload() {
            autoreload = document.getElementById('cbxAutoReload').checked;
            if (autoreload) {
                StartUpdTimer();
            }
        }

        function changeProgress(objectId,percent) {

          eval("theImg = document.getElementById('prg"+objectId+"')");
          if(percent>=0){
            theImg.width = percent;
          }
          theImg.height = 25;
        }

	//Get History Log
	function ShowHistLog() {
		OpenUrl("gethist.php");
	}

	//Get Log
	function ShowLog() {
		OpenUrl("getlog.php");
	}

	function SettingsWarning() {
		if (!frmSettingsState) {
			alert("WARNING: Any information like username and password is not encrypted. You should create cookies *ONLY* within your local network or over a secure vpn, otherwise your data may be vulnerable to others!!!");
			frmSettingsState = 1;
		}
		else frmSettingsState = 0;
		
		settings_Toggle('slow');
	}

        // Get the HTTP Object
        function getHTTPObject(){
           if (window.ActiveXObject) return new ActiveXObject("Microsoft.XMLHTTP");
           else if (window.XMLHttpRequest) return new XMLHttpRequest();
           else {
              alert("Your browser does not support AJAX.");
              return null;
           }
        }

        // Change the value of the outputText field
        function GetResponse(){
            if(httpObject.readyState == 4){
                server_response = httpObject.responseText;
                HandleIncomingData(server_response);
            }
        }

	function AbortHttpObj() {
		httpObject.abort();
		httpObject = null;
	} 

        function HandleIncomingData(data) {
            var params;
            var cmd;

	    //alert(data);
		
	    //Stop timeout
	    window.clearTimeout(glb_timeout);
            tmpLinkActivity = document.getElementById('tbxLinkActivity');
            if (tmpLinkActivity.value.length < 23) {
                tmpLinkActivity.value = " "+tmpLinkActivity.value;
            } else {
                tmpLinkActivity.value = linkactivitychar;
            }

	    if (data == "FLD_OK") {
		alert("Download path changed to: " + document.getElementById('newDownloadFolder').value);
	    }
	    else if (data == "FLD_FAIL") {
		alert("There was an error changing the download folder. Ensure that you entered a valid path. If error continues then you can try manual by editing mrb.conf in /var/hda/web-apps/myrapbook/exec/.");
	    }

	    // Responces for START button
	    else if (data == "ALREADY_STARTED") {
		alert("Daemon is already running");
		document.getElementById('txtDaemonStatus').value = 'running';
	    }
	    else if (data == "STARTED") { 
		alert("Daemon started succesfully");
		document.getElementById('txtDaemonStatus').value = 'running';
	    }
	    else if (data == "START_FAILED") {
		alert("Daemon failed to start");
		document.getElementById('txtDaemonStatus').value = 'stopped'; 
	    }	

	    // Responces for STOP button
	    else if (data == "ALREADY_STOPPED") {
		alert("Daemon is NOT running");
		document.getElementById('txtDaemonStatus').value = 'stopped';
	    }
	    else if (data == "STOPPED") { 
		alert("Daemon stopped succesfully");
		document.getElementById('txtDaemonStatus').value = 'stopped';
	    }
	    else if (data == "STOP_FAILED") { 
		alert("Daemon failed to stop");
		document.getElementById('txtDaemonStatus').value = 'running';
	    }
	    else if (data == "CLRLOG_OK") {
		alert("Logs deleted successfully.");
	    }
	    else if (data == "CLRLOG_FAILED") {
		alert("Could not delete logs.");
	    }
	    else if (data == "CLRHIST_OK") {
		alert("History deleted successfully.");
	    }
	    else if (data == "CLRHIST_FAILED") {
		alert("Could not delete history.");
	    }

	    else if (data == "COOKIE_OK") {
		document.Settings.selService.selectedIndex = 0;
		document.getElementById('txtUsername').value = "";
		document.getElementById('txtPassword').value = "";
		alert("Cookie probably created. Check validity by downloading a file.");
	    }
	    else if (data == "COOKIE_FAIL") {
		alert("There was an error creating the cookie. You can try manual.");
	    }

            else if (data == "DOWN_OK") {
                //remove first url, repeat until length = 0
                var data = document.getElementById('lstUrls');
                var links = data.value.split( /\r\n|\r|\n/ );

                if (links.length > 0) {
                    var new_textarea = new Array();
                    for (var i = 1; i<links.length; i++) {
                        new_textarea[i-1] = links[i];
                    }

                    data.value = new_textarea.join("\n");
                    sendReq(0);
                }
		return;
            }

            else {


		    var threads = data.split( /\r\n|\r|\n/,4 );
		    for (var i=0; i<4; i++) {
		        cmd = threads[i].split("=");
		        if (cmd[0] == "DSTATUS") {
		            params = cmd[1].split(",");
		            //param1=id, param2=filename, param3=filesize, param4=downsize

		            //Get thread id
		            id = params[0];

		            //Get filename
		            eval("filename = document.getElementById('txtFilename"+id+"')");

		            //Get filesize
		            eval("filesize = document.getElementById('txtFilesize"+id+"')");

		            //Get down size
		            eval("downsize = document.getElementById('txtFilesize"+id+"')");

		            eval("percent = document.getElementById('txtPerc"+id+"')");

		            if ( (params[1] == 0) && (params[2] == 0) && (params[3] == 0) ) {
		                //Get filename
		                eval("filename = document.getElementById('txtFilename"+id+"')");
		                filename.innerHTML = "No active download";
		                filesize.innerHTML = "";
		                percent.innerHTML = "";
		                changeProgress(id, 0);
		            }
		            else {


		                filename.innerHTML = params[1];

		                size = params[2];
		                size = size;

		                down = params[3];

		                filesize.innerHTML = (down/1000).toFixed(2)+" MB / "+(size/1000).toFixed(2)+" MB";

		                //Draw progressbars
		                progress = (down*glb_progress_max)/size;
		                changeProgress(id, progress);

		                perc = ((down*100)/size);
		                percent.innerHTML = perc.toFixed(2)+"%";

		            }
		        }
		    }
	    }
	    AbortHttpObj();
        }

        function CheckLink(link) {
            if (link.substring(0, 7) == "http://" )
                return true;
            else
                return false;
        }

        /* This function is called when the button is pressed,
        in order to initialize the server_response to OK*/
        function sendReqBtn() {
            server_response = "OK";
            sendReq(0);

        }
		
	/* Ajax timeout */
	function StartTimeout(seconds) {
		//glb_timeout= window.setTimeout('ajaxWatchdog()',seconds * 1000);
	}
	
	/* Timeout handler */
	function ajaxWatchdog() {
		httpObject.abort();
		httpObject = null;
		alert('Timeout');
	}

        // Implement business logic
	function sendReq(req) {
        	httpObject = getHTTPObject();
	    	if ( httpObject != null ) {
			if (req == 0) {
				//get text area lines, now data contains the text area
				var data = document.getElementById('lstUrls');
				var links = data.value.split( /\r\n|\r|\n/ );
				for (var i=0; i<1; i++) {
				    if (links[i].length > 0) {
					if (! (CheckLink(links[i])) ) {
					    alert(links[i]+" is not a valid rapidshare url!");
					}
					else {
						server_response = "";
						httpObject.open("GET", "daemoncntrl.php?cmd="
								+"DOWN"
								+"&url="
								+links[i], true);
					}
				    }
				}
			}
			else if (req == 1) {
				httpObject.open("GET", "daemoncntrl.php?cmd="
							+"DSTATUS"
							+"&url=ALL", true);
			}
			else if (req == 2) {
				httpObject.open("GET", "daemoncntrl.php?cmd=FLD&fld="+document.getElementById('newDownloadFolder').value, true);
			}
            		else if (req == 3) {
				httpObject.open("GET", "daemoncntrl.php?cmd=COOKIE&svr="+ (document.Settings.selService.selectedIndex + 1)
                                		+"&user="+document.getElementById('txtUsername').value
                                		+"&pass="+document.getElementById('txtPassword').value,true);
			}
            		else if (req == 4) {
				httpObject.open("GET", "daemoncntrl.php?cmd=START&svr=",true);
			}
            		else if (req == 5) {
				httpObject.open("GET", "daemoncntrl.php?cmd=STOP&svr=",true);
			}
            		else if (req == 6) {
				httpObject.open("GET", "daemoncntrl.php?cmd=STATUS&svr=",true);
			}
            		else if (req == 7) {
				httpObject.open("GET", "daemoncntrl.php?cmd=CLRHIST&svr=",true);
			}
            		else if (req == 8) {
				httpObject.open("GET", "daemoncntrl.php?cmd=CLRLOG&svr=",true);
			}
			httpObject.send(null);
			httpObject.onreadystatechange = GetResponse;
	    }
	    else {
		alert("no communication?");
		return;
	    }
	}
	var httpObject = null;

        //-->
        </script>

    </head>

    <body onload="init();">
        <!--// <img src="myrapbooklogo.png" alt="Logo" /> -->
		<center>
        <div class="nifty">
            <b class="rtop">
                <b class="r1"></b>
                <b class="r2"></b>
                <b class="r3"></b>
                <b class="r4"></b>
            </b>
            <div class="nifty2">
                <b class="rtop2">
                <b class="r12"></b>
                <b class="r22"></b>
                <b class="r32"></b>
                <b class="r42"></b></b>
                <center>
				<div class="header" >MyRapBook v0.2</div>
                <form name="links">
                    <p>Enter links to download:</p>
                    <p><textarea id="lstUrls" name="urls" title="Usage - Copy/paste the links you want to upload to the daemon. Current version supports Rapidshare, Netload and Hotfile services." rows="10" cols="100"></textarea></p>
					<h3 id="ToggleViewLinks" title="hide/show links list" onclick="links_Toggle()">hide/show links</h3> 
                    <p><button id="btnUploadUrls" title="Uploads urls on server" class="button" type="button" onclick="sendReqBtn();">Upload links to My Book</button></p>
                </form>

                <form name="ControlPanel">
                    	<p>Control Panel:</p>
		    	<p>
			Daemon Status: <input id="txtDaemonStatus" title="Current daemon's status" disabled="disabled" type="text" size="8" value="?">
			<button id="btnStart" title="Starts the daemon if is not already running." class="button" type="button" onclick="sendReq(4);">Start</button>
			<button id="btnStop" title="Stops the daemon if it's already running." class="button" type="button" onclick="sendReq(5);">Stop</button>
			<button id="btnGetStatus" title="Get daemon's current running status" class="button" type="button" onclick="sendReq(6);">Refresh status</button>
			</p>
                    	<h3><input id="cbxAutoReload" title="Enables/disables status' auto reload" type="checkbox" onclick="SetAutoreload();"> Autoreload downloads status every (sec): 
                    	<input id="tbxReload" title="Reload time in seconds" type="text" maxlength="3" size="2" value="2">
                    	&nbsp;&nbsp;&nbsp;Link Activity: <input id="tbxLinkActivity" title="Shows the background activity between the interface and the daemon" type="text" size="10" value="|||" ></h3>
			<center>
                   	 <p> 
			<button id="btnEditSettings" title="Edit daemon's settings" class="button" type="button" onclick="SettingsWarning();">Settings</button>
			<button id="btnGetDnlStatus" title="Get downloads' status manually" class="button" type="button" onclick="StartUpdTimer();">Download Status</button>
                        <button id="btnGetHistory" title="Get history logs" class="button" type="button" onclick="ShowHistLog();">Get History</button>
			<button id="btnGetLog" title="Get Logs" class="button" type="button" onclick="ShowLog();">Get Logs</button>
                   	</p>
			</center>
                </form>
		<form id="settingsForm" name="Settings">
			<p>Settings</p>
			<p>Download Folder: <input id="newDownloadFolder" type="text" title="Always use '/' at the end of the path!" name="txtDownloadFolder" size="42" />
			<button id="btnChangeDnlFld" title="Change download folder" class="button" type="button" onclick="sendReq(2);">Change</button></p>
			<p>
			Service____: <select name="selService" id="cbxService" size="1" title="Choose the provider, fill username & password and click Create">
				<option value="1">Rapidshare</option>
				<option value="2">Netload</option>
				<option value="3">Hotfile</option>
			</select>
			<button id="btnCreateCookie" title="Create cookie" class="button" type="button" onclick="sendReq(3);">Create</button><?php echo $services; ?></p>
			<p>Username__: <input type="text" title="Warning! No encryption" id="txtUsername"/></p>
			<p>Password__: <input type="password" title="Warning! No encryption" id="txtPassword"/></p>
			<center>
			<button id="btnClearHistory" title="Clear all history except today's history" class="button" type="button" onclick="sendReq(7);">Clear History</button>
			<button id="btnClearLog" title="Clear all logs except today's log" class="button" type="button" onclick="sendReq(8);">Clear Logs</button>
			</center>
		</form>
                <form name="f1" action="createGraph();" method="post">
                    <table id="downloads_table" border="0" cellspacing="0" cellpadding="0" width="100%">
                        <tr valign="top">
                        <p>Current downloads:</p>
                        <td>
							<h3 id="ToggleViewProgr" title="hide/show this progress" onclick="brg_Toggle('slow')">hide/show progress</h3>
                            <div id="progressBar1">
                                <h2 id="txtFilename1"></h2>
                                <img src="progress_bar.png" id="prg1" alt="File 1"/><h4 id="txtPerc1" class="txtOverImg"></h4>
                                <br><h3 id="txtFilesize1"></h3>
                            </div>
                            <div id="progressBar2">
                                <h2 id="txtFilename2"></h2>
                                <img src="progress_bar.png" id="prg2" alt="File 2"/><h4 id="txtPerc2" class="txtOverImg"></h4>
                                <br><h3 id="txtFilesize2"></h3>
                            </div>
                            <div id="progressBar3">
                                <h2 id="txtFilename3"></h2>
                                <img src="progress_bar.png" id="prg3" alt="File 3" /><h4 id="txtPerc3" class="txtOverImg"></h4>
                                <br><h3 id="txtFilesize3"></h3>
                            </div>
                            <div id="progressBar4">
                                <h2 id="txtFilename4"></h2>
                                <img src="progress_bar.png" id="prg4" alt="File 4" /><h4 id="txtPerc4" class="txtOverImg"></h4>
                                <br><h3 id="txtFilesize4"></h3>
                            </div>
                        </td>
                    </table>
                </form>
                </center>

                <center>
                    <div class="footer" >
                        GNU rapidshare/netload/hotfile downloader for WD My Book World (or any linux distribution)
                    </div>
					<!--//<button onclick="OpenUrl('http://myrapbook.sourceforge.net/');">Check for updates</button> -->
                </center>
            </div>
        </div>
		</center>
    </body>
</html>
